//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: test_project_tb.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
//  test_project_tb
//
//=============================================================================

module test_project_tb;
//-----------------------------------------------------------------------------

  import uvm_pkg::*;
  `include "uvm_macros.svh"

  import test_project_test_pkg::*;

  // import additional packages if needed

  logic clock;
  logic reset;

  //instantiate uvc interfaces

  uvc1_if    uvc1_if_i();
  uvc2_if    uvc2_if_i();
  uvc3_if    uvc3_if_i();

  assign uvc1_if_i.clock = clock;
  assign uvc1_if_i.reset = reset;
  assign uvc2_if_i.clock = clock;
  assign uvc2_if_i.reset = reset;
  assign uvc3_if_i.clock = clock;
  assign uvc3_if_i.reset = reset;

//instantiate and connect dut to interface(s) here

  initial
    begin
      uvm_config_db #(int)::set(null, "*", "recording_detail", 1);
      uvm_config_db #(virtual uvc1_if)::set(null, "uvm_test_top", "uvc1_if_i", uvc1_if_i);
      uvm_config_db #(virtual uvc2_if)::set(null, "uvm_test_top", "uvc2_if_i", uvc2_if_i);
      uvm_config_db #(virtual uvc3_if)::set(null, "uvm_test_top", "uvc3_if_i", uvc3_if_i);

      run_test();
    end

  always #10 clock = ~clock;

  initial
    begin
      clock=0;
      reset=1; //active high reset for this example
      #75 reset=0;
    end

endmodule

