//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: test_project_test1.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// test1 fortest_project:
//
//=============================================================================

`ifndef TEST_PROJECT_TEST1_SV
`define TEST_PROJECT_TEST1_SV

//-----------------------------------------------------------------------------
class test_project_test1 extends test_project_base_test;
//-----------------------------------------------------------------------------

  `uvm_component_utils(test_project_test1)
//---------------------------------------------------------------------------
// methods
//---------------------------------------------------------------------------

  extern function new(string name = "test_project_test1", uvm_component parent = null);
  extern virtual function void build_phase(uvm_phase phase);
  extern task run_phase(uvm_phase phase);
//---------------------------------------------------------------------------
// constraints
//---------------------------------------------------------------------------

endclass : test_project_test1
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Implementation
//---------------------------------------------------------------------------

function test_project_test1::new(string name = "test_project_test1", uvm_component parent = null);
   super.new(name,parent);
endfunction : new

function void test_project_test1::build_phase(uvm_phase phase);
  uvm_config_db#(int)::set(this, "env.uvc1_env_i.agent", "is_active", UVM_ACTIVE);
  uvm_config_db#(int)::set(this, "env.uvc2_env_i.agent", "is_active", UVM_ACTIVE);
  uvm_config_db#(int)::set(this, "env.uvc3_env_i.agent", "is_active", UVM_ACTIVE);
  //NEED to set configurations before calling super.build_phase() which creates the verification hierarchy.
  super.build_phase(phase);
endfunction : build_phase

task test_project_test1::run_phase(uvm_phase phase);
  test_project_default_seq vseq = test_project_default_seq::type_id::create("vseq");
    phase.raise_objection(this, "Starting virtual sequence");
    `uvm_info(get_type_name(), "Objection raised", UVM_MEDIUM)
    vseq.start(env.v_sqr);
    phase.drop_objection(this, "Finished virtual sequence");
    `uvm_info(get_type_name(), "Objection dropped", UVM_MEDIUM)
endtask : run_phase

`endif // TEST_PROJECT_TEST1_SV

