//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: uvc1_env.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// Environment for uvc1
//
//=============================================================================

`ifndef UVC1_ENV_SV
`define UVC1_ENV_SV

//-----------------------------------------------------------------------------
class uvc1_env extends uvm_env;
//-----------------------------------------------------------------------------

  uvm_active_passive_enum is_active;
  uvc1_config cfg;
  uvc1_agent  agent;
  `uvm_component_utils(uvc1_env)

  extern function new(string name = "uvc1_env", uvm_component parent);
  extern function void build_phase(uvm_phase phase);
endclass : uvc1_env 

//-----------------------------------------------------------------------------
// uvc1_config implementation
//-----------------------------------------------------------------------------
function uvc1_env::new(string name = "uvc1_env", uvm_component parent);
   super.new(name,parent);
endfunction : new

function void uvc1_env::build_phase(uvm_phase phase);
  super.build_phase(phase);
  if(!uvm_config_db #(uvc1_config)::get(this, "", "uvc1_config", cfg))
    `uvm_error(get_type_name(), "unable to get config from configuration database")
  agent = uvc1_agent::type_id::create("agent", this);

endfunction : build_phase

`endif // UVC1_ENV_SV

