//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: uvc2_coverage.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// Coverage for uvc2
//
//=============================================================================

`ifndef UVC2_COVERAGE_SV
`define UVC2_COVERAGE_SV

//-----------------------------------------------------------------------------
class uvc2_coverage extends uvm_subscriber #(uvc2_seq_item);
//-----------------------------------------------------------------------------

`uvm_component_utils_begin(uvc2_coverage)
`uvm_component_utils_end

  bit uvc2_is_covered;

  // Insert your covergroups here

  extern function new(string name = "uvc2_coverage", uvm_component parent);
  extern function void build_phase(uvm_phase phase);
  extern function void write(input uvc2_seq_item t);
  extern function void report_phase(uvm_phase phase);

endclass : uvc2_coverage 

//-----------------------------------------------------------------------------
// uvc2_coverage implementation
//-----------------------------------------------------------------------------
function uvc2_coverage::new(string name = "uvc2_coverage", uvm_component parent);
   super.new(name,parent);
   uvc2_is_covered = 0;
endfunction : new

function void uvc2_coverage::build_phase(uvm_phase phase);
  super.build_phase(phase);
endfunction : build_phase

function void uvc2_coverage::write(input uvc2_seq_item t);

endfunction : write

function void uvc2_coverage::report_phase(uvm_phase phase);
  `uvm_info(get_type_name(), "", UVM_LOW)
endfunction : report_phase

`endif // UVC2_COVERAGE_SV

