//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: uvc2_env.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// Environment for uvc2
//
//=============================================================================

`ifndef UVC2_ENV_SV
`define UVC2_ENV_SV

//-----------------------------------------------------------------------------
class uvc2_env extends uvm_env;
//-----------------------------------------------------------------------------

  uvm_active_passive_enum is_active;
  uvc2_config cfg;
  uvc2_agent  agent;
  `uvm_component_utils(uvc2_env)

  extern function new(string name = "uvc2_env", uvm_component parent);
  extern function void build_phase(uvm_phase phase);
endclass : uvc2_env 

//-----------------------------------------------------------------------------
// uvc2_config implementation
//-----------------------------------------------------------------------------
function uvc2_env::new(string name = "uvc2_env", uvm_component parent);
   super.new(name,parent);
endfunction : new

function void uvc2_env::build_phase(uvm_phase phase);
  super.build_phase(phase);
  if(!uvm_config_db #(uvc2_config)::get(this, "", "uvc2_config", cfg))
    `uvm_error(get_type_name(), "unable to get config from configuration database")
  agent = uvc2_agent::type_id::create("agent", this);

endfunction : build_phase

`endif // UVC2_ENV_SV

