//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: uvc3_coverage.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// Coverage for uvc3
//
//=============================================================================

`ifndef UVC3_COVERAGE_SV
`define UVC3_COVERAGE_SV

//-----------------------------------------------------------------------------
class uvc3_coverage extends uvm_subscriber #(uvc3_seq_item);
//-----------------------------------------------------------------------------

`uvm_component_utils_begin(uvc3_coverage)
`uvm_component_utils_end

  bit uvc3_is_covered;

  // Insert your covergroups here

  extern function new(string name = "uvc3_coverage", uvm_component parent);
  extern function void build_phase(uvm_phase phase);
  extern function void write(input uvc3_seq_item t);
  extern function void report_phase(uvm_phase phase);

endclass : uvc3_coverage 

//-----------------------------------------------------------------------------
// uvc3_coverage implementation
//-----------------------------------------------------------------------------
function uvc3_coverage::new(string name = "uvc3_coverage", uvm_component parent);
   super.new(name,parent);
   uvc3_is_covered = 0;
endfunction : new

function void uvc3_coverage::build_phase(uvm_phase phase);
  super.build_phase(phase);
endfunction : build_phase

function void uvc3_coverage::write(input uvc3_seq_item t);

endfunction : write

function void uvc3_coverage::report_phase(uvm_phase phase);
  `uvm_info(get_type_name(), "", UVM_LOW)
endfunction : report_phase

`endif // UVC3_COVERAGE_SV

