//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: uvc3_env.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// Environment for uvc3
//
//=============================================================================

`ifndef UVC3_ENV_SV
`define UVC3_ENV_SV

//-----------------------------------------------------------------------------
class uvc3_env extends uvm_env;
//-----------------------------------------------------------------------------

  uvm_active_passive_enum is_active;
  uvc3_config cfg;
  uvc3_agent  agent;
  `uvm_component_utils(uvc3_env)

  extern function new(string name = "uvc3_env", uvm_component parent);
  extern function void build_phase(uvm_phase phase);
endclass : uvc3_env 

//-----------------------------------------------------------------------------
// uvc3_config implementation
//-----------------------------------------------------------------------------
function uvc3_env::new(string name = "uvc3_env", uvm_component parent);
   super.new(name,parent);
endfunction : new

function void uvc3_env::build_phase(uvm_phase phase);
  super.build_phase(phase);
  if(!uvm_config_db #(uvc3_config)::get(this, "", "uvc3_config", cfg))
    `uvm_error(get_type_name(), "unable to get config from configuration database")
  agent = uvc3_agent::type_id::create("agent", this);

endfunction : build_phase

`endif // UVC3_ENV_SV

