//=============================================================================
// Copyright(c) Dr. Christoph Suehnel 2014 confidential, all rights reserved
//=============================================================================
// Project  : test_project
//
// File Name: uvc3_seq_item.sv
//
// Author   : Name   : Christoph Suehnel
//            Email  : christoph@christoph-suehnel.de
//            Tel    : +49 8822 835 9239
//            Company: Dr. Christoph Suehnel
//            Dept   : Consulting

// Version:

//=============================================================================
// Description:
//
// Sequence item for uvc3_sequncer
//
//=============================================================================

`ifndef UVC3_SEQ_ITEM_SV
`define UVC3_SEQ_ITEM_SV

//-----------------------------------------------------------------------------
class uvc3_seq_item  extends uvm_sequence_item; 
//-----------------------------------------------------------------------------


rand bit [1:0] addr;
rand bit [5:0] length;
rand bit [7:0] payload [];
bit [7:0] parity;
rand int packet_delay;

`uvm_object_utils_begin(uvc3_seq_item)
  `uvm_field_int(addr , UVM_ALL_ON)
  `uvm_field_int(length , UVM_ALL_ON)
  `uvm_field_array_int(payload, UVM_ALL_ON)
  `uvm_field_int(parity , UVM_ALL_ON)
  `uvm_field_int(packet_delay , UVM_ALL_ON)
`uvm_object_utils_end

function new(string name="uvc3_seq_item");
   super.new(name);
endfunction : new

endclass : uvc3_seq_item 

`endif // UVC3_SEQ_ITEM_SV

